/*
    Drools4 Integration Helper
    Copyright (C) 2009  Mathieu Boretti mathieu.boretti@gmail.com

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.boretti.drools.integration.drools4;

import org.boretti.drools.integration.drools4.implementation.DroolsProviderImplementation;
import org.drools.RuleBase;

/**
 * This class provide a way to get a concrete proxy of an interface.
 * @author mbo
 *
 */
public class DroolsProvider {
	/**
	 * This is the method to be call to get the service.
	 * @param clazz
	 * @return The concrete instance (Proxy), based on the interface
	 */
	public <T> T getService(Class<T> clazz) {
		return DroolsProviderImplementation.getInstance().getService(clazz);
	}
	
	/**
	 * This is the method to get a rule base from an annotated class.
	 * @param clazz
	 * @return the rule base
	 * @since 1.1.0
	 */
	public <T> RuleBase getRuleBase(Class<T> clazz) {
		return DroolsProviderImplementation.getInstance().getRuleBase(clazz);
	}
}
